<?php

/**
 * @file
 * Page display functions for for gigya module.
 */

/**
 * 
 * 
 */
function gigya_connect($account, $name = NULL) {
	
  global $base_url;
    
  module_load_include('inc', 'gigya');
  $title = isset($account->title) ? $account->title : $account->name;
  drupal_set_title(check_plain($title));

  $form = array();
  gigya_login_block_js();
  
  $bio = gigya_getUserInfo($account->uid);
       
  if ($bio['isConnected'] == 1 || $bio['isConnected'] == true) {
    
    if (variable_get('gigya_connect_uiconfig_raw', '')) {
      $connect_UIConfig = variable_get('gigya_connect_uiconfig_raw', '');
    }
    else {
      $connect_UIConfig = "<config><body><captions background-color=\"". variable_get('gigya_connect_uiconfig_color_caption_background', GIGYA_DEFAULT_CONNECTUI_COLOR_CAPTION_BACKGROUND) ."\" color=\"". variable_get('gigya_connect_uiconfig_color_caption_text', GIGYA_DEFAULT_CONNECTUI_COLOR_CAPTION_TEXT) ."\"></captions><texts color=\"". variable_get('gigya_connect_uiconfig_color_text', GIGYA_DEFAULT_CONNECTUI_COLOR_TEXT) ."\"><links color=\"". variable_get('gigya_connect_uiconfig_color_link', GIGYA_DEFAULT_CONNECTUI_COLOR_LINK) ."\"></links></texts><controls><snbuttons buttonsize=\"". variable_get('gigya_connect_uiconfig_iconsize', GIGYA_DEFAULT_ICONSIZE) ."\" color=\"". variable_get('gigya_connect_uiconfig_color_button_text', GIGYA_DEFAULT_CONNECTUI_COLOR_BUTTON_TEXT) ."\"></snbuttons><scrollingarrow color=\"". variable_get('gigya_connect_uiconfig_color_navigation_arrow', GIGYA_DEFAULT_CONNECTUI_COLOR_NAVIGATION_ARROW) ."\"></scrollingarrow></controls><background background-color=\"". variable_get('gigya_connect_uiconfig_color_background', GIGYA_DEFAULT_CONNECTUI_COLOR_BACKGROUND) ."\" frame-color=\"". variable_get('gigya_connect_uiconfig_color_frame', GIGYA_DEFAULT_CONNECTUI_COLOR_FRAME) ."\"></background></body></config>";
    }
  }
  
  $gigya_connect_params = array(
    'connect_params' => array(
      "headerText" => variable_get('gigya_connect_uiconfig_captionText', GIGYA_DEFAULT_CONNECTUI_CAPTIONTEXT),
      "width" => variable_get('gigya_connect_uiconfig_width', GIGYA_DEFAULT_CONNECTUI_WIDTH),
      "height" => variable_get('gigya_connect_uiconfig_height', GIGYA_DEFAULT_CONNECTUI_HEIGHT),
      "containerID" => variable_get('gigya_connect_uiconfig_containerID', GIGYA_DEFAULT_CONNECTUI_CONTAINERID),
      "showTermsLink" => variable_get('gigya_connect_uiconfig_terms', TRUE),
      "hideGigyaLink" => variable_get('gigya_connect_uiconfig_branding', TRUE),
      "useFacebookConnect" => variable_get('gigya_login_advanced_facebookconnect', GIGYA_DEFAULT_LOGINUI_FBCONNECT),
      "UIConfig" => $connect_UIConfig,
    ),
  );
  drupal_add_js(array('gigya' => $gigya_connect_params), 'setting');    
  $form['gigya'] = array(
    '#type' => 'fieldset',
    '#theme' => 'gigya_connect_display',
    '#description' => t('You may connect your profile to additional social networks here.'),
  );

  $form['gigya']['connect'] = array(
    '#weight' => 10,
    '#value' => '&nbsp;',
    '#prefix' => '<div class="gigya editConnectionsUI"><strong>Social Network Connections</strong><div id="'. variable_get('gigya_connect_uiconfig_containerID', GIGYA_DEFAULT_CONNECTUI_CONTAINERID) .'">',
    '#suffix' => '</div><script type="text/javascript">
        var connect_params = Drupal.settings.gigya.connect_params;
        connect_params.width = parseInt(connect_params.width);
        connect_params.height = parseInt(connect_params.height);
        gigya.services.socialize.showEditConnectionsUI(Drupal.settings.gigya.conf,connect_params);</script></div>',
  );

  return drupal_render($form);
}

function gigya_shareui_ajax($currObj,$objType,$objID,$currUrl) {          
  $shareUI_js = gigya_shareUI_js($currObj,$objType,$objID,$currUrl);
  drupal_add_js($shareUI_js,'inline'); 
  return '<div id="shareUI">'. t("Please wait for the shareUI component of socialize") .'</div>';
}

function gigya_logout_ajax() {
  global $user, $base_path;
  module_load_include('.inc', 'user', 'user.pages');
  module_load_include('inc', 'gigya');

  $dest = $_REQUEST['destination'];
  if(empty($dest)) $dest = $base_path;
  $logout_behavior = array("logout_location" => $base_path);
  
  drupal_add_js(array('gigya' => $logout_behavior), 'setting');

  $behavior_js = 'Drupal.behaviors.gigya_logout = function(){ gigya.services.socialize.logout(Drupal.settings.gigya.conf, {callback:Drupal.gigya.logoutResponse});};';
  drupal_add_js($behavior_js, 'inline');
  variable_set('remove_user_login_title', FALSE);
  return '<div id="logoutMessage">'. t("Logging out...") .'</div>';
}


function gigya_login_ajax() {

  global $user, $base_path;
  
  drupal_set_message('gigya_login_ajax u:' . $user->uid > 0);
  module_load_include('inc', 'gigya'); 
  
	if (!($user->uid)) { //not yet logged in to Drupal
  
    if($_gigya_user = GigyaUser::UserFromUrl()){
         
      $dest = $base_path . variable_get('gigya_login_uiconfig_urlredirect', 'user');
    
      $bio = $_gigya_user->GetUserInfo();
          
      //check to see if the gigya_user is a drupal user
      if ($account = user_load($_gigya_user->uid)) {    
        if (!variable_get('user_email_verification', true) || $account->login) {
          //we can suppress the notifylogin js because the user is clearly already logged into gigya
          $_SESSION['gigya_suppress_notifylogin_js'] = true;
          
          //log the user in
          user_external_login($account);
        }
        else {
          drupal_set_message(t('You must validate your email address for this account before logging in via Gigya.'));
        }
        drupal_goto();
      }
      elseif(variable_get('user_register', 1)){ //try to register them if we're allowed to
        $form_state['redirect'] = NULL;
        $form_state['values']['name'] = (empty($bio['nickname']) ? '' : $bio['nickname']);
        $form_state['values']['mail'] = (empty($bio['email']) ? '' : $bio['email']);
        $form_state['values']['pass']  = user_password();
        $form_state['values']['status'] = variable_get('user_register', 1) == 1;  
        
        $xxx = gigya_printObject('',$form_state);
        //watchdog('gigya', 'b4 drupal_retrieve_form:' . $xxx);
        $form = drupal_retrieve_form('user_register', $form_state);
        
        $xxx = gigya_printObject('',$form);
        //watchdog('gigya', 'b4 drupal_prepare_form:' . $xxx);
        drupal_prepare_form('user_register', $form, $form_state);
        
        $xxx = gigya_printObject('',$form);
        watchdog('gigya', 'b4 drupal_validate_form:' . $xxx);
        drupal_validate_form('user_register', $form, $form_state);
      
        if (form_get_errors()) {
            // Append form validation errors below the above warning.
            $messages = drupal_get_messages('error');
              
            $xxx = gigya_printObject('',$messages);
            // We were unable to register a valid new user
            watchdog('gigya', 'error:' . $xxx);
            drupal_goto('socialize-register',array('signature'=>$_GET['signature'],'UID'=>$_GET['UID'],'timestamp'=>$_GET['timestamp']));            
        }
        else {
          //save the new user
          $account = user_save('', $form_state['values']);//possibly replace with drupal_process_form('user_register', $form, $form_state) ?
          // Terminate if an error occured during user_save().
          if (!$account) {
            drupal_set_message(t("Error saving user account."), 'error');
            drupal_goto();
          }
          //log in after registration -- maybe this should be an option to turn off/on?
          user_external_login($account);
        }
        drupal_redirect_form($form, $form_state['redirect']);
      }
      else {
        drupal_set_message(t('Only site administrators can create new user accounts.'), 'error');
      }
  	}    
	}	
  drupal_goto();
	
}

/**
 * AJAX function to handle various requests to gigya
 * for now it's just used to set session variables for the javascript
 */
function gigya_ajax($op){
  switch($op){
    case 'notify-login':
      $_SESSION['gigya_suppress_notifylogin_js'] = true;
    break;
    case 'link-accounts-complete':
      $_SESSION['link_accounts'] = false;
    break;
    case 'logout':
      
    break;
  }
  exit();
}


/**
 */
function gigya_get_friends($account, $name = NULL) {
  $title = isset($account->title) ? $account->title : $account->name;
  drupal_set_title(check_plain($title));

  module_load_include('inc', 'gigya');
  $site_friends = array();
  $this_gigya_user = new GigyaUser($account->uid);
  if ($friends = $this_gigya_user->GetFriends()) {
    foreach ($friends['friends']->friend as $friend) {
      $friend_arr = get_object_vars($friend);
      if ($friend_arr['isSiteUser'] === 'true')
        $site_friends[] = $friend_arr;
    }
  }

  return theme('gigya_friends', $site_friends);
}

/**
 * Wrapper for the gigya javascript userInfo function.
 * injects the gigya getUserInfo javascript function.
 */
function gigya_get_user($object, $name = NULL) {
  $title = isset($object->title) ? $object->title : $object->name;
  drupal_set_title(check_plain($title));

  //add the onload functions  
  $behavior_js = 'Drupal.behaviors.gigya_getUserInfo = function(context){ gigya.services.socialize.getUserInfo(Drupal.settings.gigya.conf, {callback:Drupal.gigya.getUserInfo_callback}); }';
  drupal_add_js($behavior_js, 'inline');

  $userinfo = '<div id="userinfo"></div>';
  return $userinfo;

}

function gigya_setStatus_form($form_state, $hook, $id) {
  global $user;

  $form = array();
  $msg = $_SESSION['setStatus_msg'];
  $default = $_SESSION['setStatus_default'];
    
  if ($hook == 'user') {
    $account = user_load($id);
    $form['uid'] = array('#type' => 'value', '#value' => $id);
  }
  if ($hook == 'node') {
    $node = node_load($id);
    $form['nid'] = array('#type' => 'value', '#value' => $id);
  }

  $form['status'] = array(
    '#type' => 'textarea',
    '#title' => t('Update Status'),
    '#description' => $msg,
    '#default_value' => $default,
    '#cols' => 60,
    '#rows' => 3,
    '#resizable' => FALSE,
    
  );
  $form['hide'] = array(
    '#type' => 'checkbox',
    '#title' => t('Never Show this Again'),
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Send'),
  );
  $form['close'] = array(
    '#type' => 'submit',
    '#value' => t('Close'),
  	'#attributes' => array(
      'onClick' => "Popups.close();",
    ),
  );


  $form['gigya_uid'] = array('#type' => 'value', '#value' => $user->uid);
  return $form;
}

function gigya_setStatus_form_submit($form, &$form_state) {

  global $user;

  if (isset($form_state['values']['nid'])) {
    $node = node_load($form_state['values']['nid']);

    $replacements = array('!title' => $node->title,
                        '!url' => url('node/'. $node->nid, array('absolute' => TRUE, 'alias' => TRUE)),
                        '!url-alias' => url('node/'. $node->nid, array('absolute' => TRUE)),
                        '!user' => $node->name);
    // Only generate the shortened URL if it's going to be used. No sense
    // burning through TinyURLs without a good reason.
    if (strstr($form_state['values']['status'], '!tinyurl') !== FALSE) {
      $replacements['!tinyurl'] = gigya_shorten_url(url('node/'. $node->nid, array('absolute' => TRUE)));
    }
  }
  else if (isset($form_state['values']['uid'])) {
    $account = node_load($form_state['values']['uid']);
    $replacements = array('!profileurl' => url('user/'. $user->nid, array('absolute' => TRUE)),
                          '!user' => $user->name,
                          '!sitename' => variable_get('site_name', ''),
                          );

  }

  switch ($form_state['values']['op']) {
    case 'Send':
      $status = strtr($form_state['values']['status'], $replacements);
      gigya_setStatus($_SESSION['gigya_uid'], $status);
      user_save($user, array('setStatus_popup_hide' => $form_state['values']['hide'] ? TRUE : FALSE));
      drupal_set_message('Update sent to social networks successfully!');
      break;
    case 'Close':
      user_save($user, array('setStatus_popup_hide' => $form_state['values']['hide'] ? TRUE : FALSE));
      break;
    default:

      break;
  }
}

function gigya_notify_friends($node) {

  module_load_include('inc', 'gigya');   
  popups_add_popups();
  global $user, $base_root;
  $title = check_plain(variable_get('gigya_share_link_title', GIGYA_DEFAULT_SHARE_LINK_TITLE));

  drupal_set_title($title);
  $friends = gigya_getFriendsInfo($user->uid);

  if (variable_get('gigya_friends_uiconfig_raw', '')) {
    $friends_uiconfig = variable_get('gigya_friends_uiconfig_raw', '');
  }
  else {
    $friends_uiconfig = "<config><body><captions background-color=\"". variable_get('gigya_friends_uiconfig_color_caption_background', GIGYA_DEFAULT_FRIENDSUI_COLOR_CAPTION_BACKGROUND) ."\" color=\"". variable_get('gigya_friends_uiconfig_color_caption_text', GIGYA_DEFAULT_FRIENDSUI_COLOR_CAPTION_TEXT) ."\"></captions><texts color=\"". variable_get('gigya_friends_uiconfig_color_text', GIGYA_DEFAULT_FRIENDSUI_COLOR_TEXT) ."\"><links color=\"". variable_get('gigya_friends_uiconfig_color_link', GIGYA_DEFAULT_FRIENDSUI_COLOR_LINK) ."\"></links></texts><controls><snbuttons color=\"". variable_get('gigya_friends_uiconfig_color_button_text', GIGYA_DEFAULT_FRIENDSUI_COLOR_BUTTON_TEXT) ."\"></snbuttons><scrollingarrow color=\"". variable_get('gigya_friends_uiconfig_color_navigation_arrow', GIGYA_DEFAULT_FRIENDSUI_COLOR_NAVIGATION_ARROW) ."\"></scrollingarrow></controls><background background-color=\"". variable_get('gigya_friends_uiconfig_color_background', GIGYA_DEFAULT_FRIENDSUI_COLOR_BACKGROUND) ."\" frame-color=\"". variable_get('gigya_friends_uiconfig_color_frame', GIGYA_DEFAULT_FRIENDSUI_COLOR_FRAME) ."\"></background></body></config>";
  }

  $gigya_friends_params = array(
    'friendsUI_params' => array(
      "width" => variable_get('gigya_friends_uiconfig_width', GIGYA_DEFAULT_FRIENDSUI_WIDTH),
      "height" => variable_get('gigya_friends_uiconfig_height', GIGYA_DEFAULT_FRIENDSUI_HEIGHT),
    //  "containerID" => variable_get('gigya_friends_uiconfig_containerID', GIGYA_DEFAULT_FRIENDSUI_CONTAINERID),
      "showCaption" => variable_get('gigya_friends_uiconfig_showCaption', GIGYA_DEFAULT_FRIENDSUI_SHOWCAPTION),
      "captionText" => variable_get('gigya_friends_uiconfig_captionText', GIGYA_DEFAULT_FRIENDSUI_CAPTIONTEXT),
      "UIConfig" => $friends_uiconfig,
    ),
  );
  
  drupal_add_js(array('gigya' => $gigya_friends_params), 'setting');
  $attach_behaviors_js = 'Drupal.attachBehaviors()';
  drupal_add_js($attach_behaviors_js, 'inline');

  $notification_setting = array(
    'notifyMsg' => $context->title,
  );

  drupal_add_js(array('gigya' => $notification_setting), 'setting');
  $msg = variable_get('gigya_share_message', '');
  $current_url = url('node/'.$node->nid,array('absolute' => TRUE));
  $urltitle = variable_get('gigya_friends_uiconfig_link_title',false) ? variable_get('gigya_friends_uiconfig_link_title',false) : url('node/'.$node->nid,array('absolute' => TRUE));
  $output = '
   <form id="socialize_notification" name="socialize_notification">
   <div id="socialize_notification_msg">   
      <label id="notify_MsgLabel" style="vertical-align: top; align:left;">Your message:</label><br/>
      <label id="notify_WaitLabel" style="vertical-align: top; align:left; display:none;">Please wait: Notification is being sent...</label>      
      <textarea id="notify_message" style="width 20%; padding:2px;" id="body" name="body" cols="30" rows="6">'. $msg .'</textarea>
      <input type="hidden" id="url" name="url" value="'.  $current_url . '" />      
      <input type="hidden" id="urltitle" name="urltitle" value="'. $urltitle .'" />
    </div>
    <div class="friends-ui" id="'. variable_get('gigya_friends_uiconfig_containerID', GIGYA_DEFAULT_FRIENDSUI_CONTAINERID) .'" style="width:'. variable_get('gigya_friends_uiconfig_width', GIGYA_DEFAULT_FRIENDSUI_WIDTH) .'px; height:'. variable_get('gigya_friends_uiconfig_height', GIGYA_DEFAULT_FRIENDSUI_HEIGHT) .'px; padding-left:53px;">      
      <div id="friends"></div> 
    </div>             
   </form>
   <div id="status"></div> ';  
  return $output;
}

function gigya_register(){
 
  global $user;

  // If we are already logged on, go to the user page instead.
  if ($user->uid) {
    drupal_goto('user/'. $user->uid);
  }
  
  if (!($_gigya_user = GigyaUser::UserFromUrl())) {
    drupal_goto();
  }
  $bio = $_gigya_user->GetUserInfo(TRUE);
      
  $registration_form = drupal_get_form('user_register');
  $link_accounts_form = drupal_get_form('gigya_link_accounts');
  return theme('gigya_register',$bio,$registration_form,$link_accounts_form);
}